/* $Id: Method.java,v 1.1 2004/08/24 11:41:29 yuk Exp $
 * create: 2004/08/24
 * (c)2004 Lavans Networks Inc. All Rights Reserved.
 */
package com.lavans.util;

import java.util.HashSet;
import java.util.Set;

/**
 * @author dobashi
 * @version 1.00
 */
public class Method extends BaseClass {
	private static Set ignoreList = new HashSet();
	public static void addIgnore(String value){
		ignoreList.add(value);
	}
	public static boolean removeIgnore(String value){
		return ignoreList.remove(value);
	}

	/**
	 * \bh̎擾B
	 * LogRecord#inferCaller()̃pNB
	 * 
	 * @see java.util.loggin.LogRecord#inferCaller
	 *
	 */
	public static String getMethodName(String classname) {
		//logger.entering("Method","getMethodName");
		//logger.debug("classname="+ classname);
		
		// Get the stack trace.
		StackTraceElement stack[] = (new Throwable()).getStackTrace();
		// First, search back to a method in the Logger class.
		int ix = 0;
		while (ix < stack.length) {
			StackTraceElement frame = stack[ix];
			String cname = frame.getClassName();
			//logger.log(cname);
			if (classname.equals(cname)) {
				break;
			}
			ix++;
		}
		// Now search for the first frame before the "Logger" class.
		while (ix < stack.length) {
			StackTraceElement frame = stack[ix];
			String cname = frame.getClassName();
			//logger.log(cname+"#"+frame.getMethodName() +"()");
			if (!classname.equals(cname) && !ignoreList.contains(cname)) {
				//logger.exiting("Logger","getMethodName");
//				return frame.toString();
				return cname+"#"+frame.getMethodName() +"()";
//				return cname+"#"+frame.getMethodName() +"("+frame.getFileName() +":"+ frame.getLineNumber() +")";
			}
			ix++;
		}
		
		//logger.exiting("Method","getMethodName");
		return "";
	}
}
